package sets;


import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;


// read/write node that can be marked valid/invalid
class ValidatedNode<T> extends ReadWriteNode<T>
{
    private volatile boolean valid;  // is node valid?

    @Override
    public boolean valid() {
        return valid;
    }

    @Override
    public boolean setValid() {
        valid = true;
        return true;
    }

    @Override
    public boolean setInvalid() {
        valid = false;
        return true;
    }

    ValidatedNode(T item) {
        super(item);
        setValid();
    }

    ValidatedNode(int key) {
        super(key);
        setValid();
    }
}
